Run the normal and the test wgt
[src/qa-testdefinitions.git] / common / scripts / application-lifecycle.sh
index 0bc7f08..bdb6afc 100755 (executable)
@@ -30,6 +30,7 @@ fi
 
 do_afm_util()
 {
+set -x
        if [ $SERVICE_USER -eq 1 -o $APPLICATION_USER -eq 1 ];then
                su - $AGLDRIVER -c "afm-util $*"
        else
@@ -38,28 +39,55 @@ do_afm_util()
        return $?
 }
 
-wget -q $BASEURL -O index.html
-if [ $? -ne 0 ];then
-       echo "ERROR: Cannot wget $BASEURL"
-       exit 1
+do_afm_test()
+{
+set -x
+       if [ $SERVICE_USER -eq 1 -o $APPLICATION_USER -eq 1 ];then
+               su - $AGLDRIVER -c "aft-test $*"
+       else
+               afm-test -l $*
+       fi
+       return $?
+}
+
+if [ ! -f index.html ] ; then
+       wget -q $BASEURL -O index.html
+       if [ $? -ne 0 ];then
+           echo "ERROR: Cannot wget $BASEURL"
+               exit 1
+       fi
 fi
 
+WGTNAME="$(grep -o '[a-z-]*.wgt' index.html | sed 's,.wgt$,,' | sed 's,-debug$,,' | sed 's,-coverage$,,' | sed 's,-test$,,' | uniq)"
+
 grep -o '[a-z-]*.wgt' index.html | sort | uniq |
 while read wgtfile
 do
-       WGTNAME=$(echo $wgtfile | sed 's,.wgt$,,')
-       SERVICE_PLATFORM=0
-       SERVICE_USER=0
-       APPLICATION_USER=0
+       # remove extension and the debug state
+       #export WGTNAME=$(echo $wgtfile | sed 's,.wgt$,,' | sed 's,-debug$,,' | sed 's,-coverage$,,' | sed 's,-test$,,')
        echo "DEBUG: fetch $wgtfile"
-       wget -q $BASEURL/$wgtfile
-       if [ $? -ne 0 ];then
-               echo "ERROR: wget from $BASEURL/$wgtfile"
-               continue
+
+       if [ ! -f $wgtfile ] ; then
+               wget -q $BASEURL/$wgtfile
+               if [ $? -ne 0 ];then
+                       echo "ERROR: wget from $BASEURL/$wgtfile"
+                       continue
+               fi
        fi
+done
+
+echo "$WGTNAME"
+
+inspectwgt() 
+{
+
+       wgtfile=$1
+       CURDIR="$(pwd)"
+       ZIPOUT="$(mktemp -d)"
+       cd $ZIPOUT
 
        echo "DEBUG: analyse wgt file"
-       unzip $wgtfile
+       unzip $CURDIR/$wgtfile
        if [ $? -ne 0 ];then
                # TODO Do not fail yet, busybox unzip seems to "fail with success" when checking CRC
                echo "ERROR: cannot unzip $wgtfile"
@@ -77,19 +105,38 @@ do
                    # we are a service, now determine the scope ...
                    grep "urn:AGL:permission::partner:scope-platform" config.xml
                    if [ $? -eq 0 ];then
-                       SERVICE_PLATFORM=1
+                       export SERVICE_PLATFORM=1
                    else
-                       SERVICE_USER=1
+                       export SERVICE_USER=1
                    fi
                else
                    # we are an application
-                   APPLICATION_USER=1
+                   export APPLICATION_USER=1
                    # no other type known (yet)
                fi
        else
                echo "DEBUG: fail to unzip"
        fi
 
+       cd $CURDIR
+       rm -r $ZIPOUT
+
+}
+
+# cases:
+# a) (release).wgt -> lifecycle
+# b) -test.wgt -> run afm-test $wgt
+# later: c) -coverage wgt -> install coverage AND run afm-test $wgt
+for RUNIT in runrelease runtest ; do
+
+    SERVICE_PLATFORM=0
+    SERVICE_USER=0
+    APPLICATION_USER=0
+
+    if [ x"runrelease" = x"$RUNIT" ] ; then
+       eval wgtfile="${WGTNAME}.wgt"
+       inspectwgt $wgtfile
+
        echo "DEBUG: list current pkgs"
        # TODO mktemp
        LIST='list'
@@ -104,20 +151,20 @@ do
        fi
 
        echo "DEBUG: check presence of $WGTNAME"
-       NAMEID=$(grep id\\\":\\\"${WGTNAME}@ $LIST | cut -d\" -f4 | cut -d\\ -f1)
+       NAMEID=$(grep id\\\":\\\"${WGTNAME}\" $LIST | cut -d\" -f4 | cut -d\\ -f1)
        if [ ! -z "$NAMEID" ];then
                echo "DEBUG: $WGTNAME already installed as $NAMEID"
                # need to kill then deinstall
-               afm-util ps --all | grep -q $WGTNAME
+               do_afm_util ps --all | grep -q $WGTNAME
                if [ $? -eq 0 ];then
                        echo "DEBUG: kill $WGTNAME"
-                       afm-util kill $WGTNAME
+                       do_afm_util kill $WGTNAME
                        if [ $? -ne 0 ];then
                                echo "ERROR: afm-util kill"
-                               lava-test-case afm-util-pre-kill-$WGTNAME --result fail
-                               continue
-                       else
-                               lava-test-case afm-util-pre-kill-$WGTNAME --result pass
+                               #lava-test-case afm-util-pre-kill-$WGTNAME --result fail
+                               #continue
+                       #else
+                       #       lava-test-case afm-util-pre-kill-$WGTNAME --result pass
                        fi
                else
                        echo "DEBUG: no need to kill $WGTNAME"
@@ -127,8 +174,9 @@ do
                afm-util remove $NAMEID
                if [ $? -ne 0 ];then
                        echo "ERROR: afm-util remove"
-                       lava-test-case afm-util-remove-$WGTNAME --result fail
-                       continue
+                       #lava-test-case afm-util-remove-$WGTNAME --result fail
+                       journalctl -b | tail -40
+                       #continue
                else
                        lava-test-case afm-util-remove-$WGTNAME --result pass
                fi
@@ -148,9 +196,12 @@ do
                lava-test-case afm-util-install-$WGTNAME --result pass
        fi
        # message is like \"added\":\"mediaplayer@0.1\"
-       NAMEID=$(grep d\\\":\\\"${WGTNAME}@ $OUT | cut -d\" -f4 | cut -d\\ -f1)
+       NAMEID=$(grep d\\\":\\\"${WGTNAME}\" $OUT | cut -d\" -f4 | cut -d\\ -f1)
        if [ -z "$NAMEID" ];then
                echo "ERROR: Cannot get nameid"
+               echo "DEBUG: ========== DUMPING output =========="
+               cat $OUT
+               echo "DEBUG: ========== END DUMP =========="
                continue
        fi
        echo "DEBUG: $WGTNAME is installed as $NAMEID"
@@ -183,24 +234,25 @@ do
        fi
 
        echo "DEBUG: check if we see the package with systemctl list-units (before start)"
-       systemctl list-units --full | grep "afm.*$WGTNAME"
+       systemctl list-units --full | grep "afm.*$WGTNAME--"
        echo "DEBUG: check if we see the package with systemctl -a (before start)"
-       systemctl -a |grep "afm.*$WGTNAME"
+       systemctl -a |grep "afm.*$WGTNAME--"
 
        echo "DEBUG: start $NAMEID"
        do_afm_util start $NAMEID > "rid"
        if [ $? -ne 0 ];then
                echo "ERROR: afm-util start"
                lava-test-case afm-util-start-$WGTNAME --result fail
+               journalctl -an 200
                continue
        else
                lava-test-case afm-util-start-$WGTNAME --result pass
        fi
 
        echo "DEBUG: check if we see the package with systemctl list-units (after start)"
-       systemctl list-units --full | grep "afm.*$WGTNAME"
+       systemctl list-units --full | grep "afm.*$WGTNAME--"
        echo "DEBUG: check if we see the package with systemctl -a (after start)"
-       systemctl -a |grep "afm.*$WGTNAME"
+       systemctl -a |grep "afm.*$WGTNAME--"
 
        echo "DEBUG: Get RID for $NAMEID"
        PSLIST="pslist"
@@ -215,6 +267,23 @@ do
        fi
        # TODO, compare RID with the list in $PSLIST"
        RID="$(cat rid)"
+       if [ "$RID" == 'null' ];then
+               sleep 20
+               echo "DEBUG: retry start $NAMEID"
+               do_afm_util start $NAMEID > "rid"
+               if [ $? -ne 0 ];then
+                       echo "ERROR: afm-util start"
+                       lava-test-case afm-util-start-$WGTNAME --result fail
+                       continue
+               fi
+               RID="$(cat rid)"
+       fi
+
+       if [ "$RID" == 'null' ];then
+               echo "ERROR: RID is null, service fail to start"
+               lava-test-case afm-util-status-$WGTNAME --result fail
+               continue
+       fi
 
        echo "DEBUG: status $NAMEID ($RID)"
        do_afm_util status $RID
@@ -237,12 +306,37 @@ do
        fi
 
        echo "DEBUG: start2 $NAMEID"
-       do_afm_util start $NAMEID
+       do_afm_util start $NAMEID > rid
        if [ $? -ne 0 ];then
                echo "ERROR: afm-util start2"
                lava-test-case afm-util-start2-$WGTNAME --result fail
+               journalctl -an 200
                continue
        else
                lava-test-case afm-util-start2-$WGTNAME --result pass
        fi
+       RID="$(cat rid)"
+       if [ "$RID" == 'null' ];then
+               echo "ERROR: RID is null"
+               continue
+       fi
+       sleep 120
+       echo "DEBUG: status2 $NAMEID ($RID)"
+       do_afm_util status $RID
+       if [ $? -ne 0 ];then
+               echo "ERROR: afm-util status2"
+               lava-test-case afm-util-status2-$WGTNAME --result fail
+               continue
+       else
+               lava-test-case afm-util-status2-$WGTNAME --result pass
+       fi
+    fi
+    if [ x"runtest" = x"$RUNIT" ] ; then
+       eval wgtfile="${WGTNAME}-test.wgt"
+       inspectwgt $wgtfile
+       afm-test -l $wgtfile
+       journalctl -b | grep ${WGTNAME}-test
+       ( journalctl -b | grep ${WGTNAME}-test | grep ERROR ) || true   
+    fi
+
 done